;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Busy soft ;; 30.01.2024 ;; Shortest Win32 Hello World with imports ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	USE32			; Compiled in Flat assembler 1.71.39
	ORG	0x400000

base	db	'MZbsPE',0,0	; Signatures ( bs=busy soft:) )

;; COFF header

	dw	0x014C		; MZ+08 PE+04 Target Machine (Intel 386)
	dw	1		; MZ+0A PE+06 NumberOfSections

;;	dd	-1		; MZ+0C PE+08 TimeDateStamp		UNUSED
;;	dd	-1		; MZ+10 PE+0C PointerToSymbolTable	UNUSED
;;	dd	-1		; MZ+14 PE+10 NumberOfSymbols		UNUSED

hello	db	'Hello world',0

	dw	optlen		; MZ+18 PE+14 SizeOfOptionalHeader
	dw	0x0002		; MZ+1A PE+16 Characteristics (2=executable)

; Optional header

optzac:	dw	0x010B		; MZ+1C PE+18 Magic (PE32 32bit EXE)

;;	db	-1		; MZ+1E PE+1A MajorLinkerVersion	UNUSED
;;	db	-1		; MZ+1F PE+1B MinorLinkerVersion	UNUSED
;;	dd	-1		; MZ+20 PE+1C SizeOfCode		UNUSED
;;	dd	-1		; MZ+24 PE+20 SizeOfInitData		UNUSED
;;	dd	-1		; MZ+28 PE+24 SizeOfUninitData		UNUSED

msgbox	db	0,0		; Import item pointed by IAT
	db	'MessageBoxA'
	db	0

	dd	start - base	; MZ+2C PE+28 AddressOfEntryPoint
;;	dd	-1		; MZ+30 PE+2C BaseOfCode		UNUSED
;;	dd	-1		; MZ+34 PE+30 BaseOfData		UNUSED

idatx:				; Important part of import table
idata	=	idatx - 0x0C
	dd	user32_txt - base	; Library name
	dd	user32_iat - base	; Import address table IAT

; Windows specific fields

	dd	base		; MZ+38 PE+34 ImageBase
	dd	4		; MZ+3C PE+38 SectionAlignment => PE offset +4
	dd	4		; MZ+40 PE+3C FileAlignment

;	dw	-1		; MZ+44 PE+40 MajorOperatingSystemVersion	UNUSED
;	dw	-1		; MZ+46 PE+42 MinorOperatingSystemVersion	UNUSED
;	dw	-1		; MZ+48 PE+44 MajorImageVersion			UNUSED
;	dw	-1		; MZ+4A PE+46 MinorImageVersion			UNUSED

user32_iat:			; Import address table IAT
MessageBoxA:
	dd	msgbox - base	; This address of text will be replaced by address of API
	dd	0		; End of IAT

	dw	4		; MZ+4C PE+48 MajorSubsystemVersion
;;	dw	-1		; MZ+4E PE+4A MinorSubsystemVersion		UNUSED
;;	dd	-1		; MZ+50 PE+4C Win32VersionValue			UNUSED
;;	dd	0x10000		; MZ+54 PE+50 SizeOfImage

start:	mov	ebx,hello	; Entry point
	jmp	sem1		;  Low byte  SizeOfImage
	db	1,0,0		; Next bytes SizeOfImage

	dd	0x00		; MZ+58 PE+54 SizeOfHeaders
;;	dd	-1		; MZ+5C PE+58 CheckSum			UNUSED

sem1:	xor	eax,eax		; Part of code placed into checksum
	jmp	sem2

	dw	2		; MZ+60 PE+5C Subsystem (Win32 GUI)
	dw	0		; MZ+62 PE+5E DllCharacteristics

	dd	0x1000		; MZ+64 PE+60 SizeOfStackReserve
	dd	0x1000		; MZ+68 PE+64 SizeOfStackCommit
	dd	0x1000		; MZ+6C PE+68 SizeOfHeapReserve
	dd	0x00		; MZ+70 PE+6C SizeOfHeapCommit

	dd	0		; MZ+74 PE+70 LoaderFlags		UNUSED
	dd	2		; MZ+78 PE+74 NumberOfRvaAndSizes

; Data directories (only import data address needed)

;;	dd	-1		; MZ+7C PE+78 Export data	UNUSED
;;	dd	-1		; MZ+80 PE+7C Export size	UNUSED

user32_txt:
	db	'user32',0,0	; Name of imported library

	dd	idata - base	; MZ+84 PE+80 Import data
;;	dd	-1		; MZ+88 PE+84 Import size	UNUSED

optlen	=	$-optzac+4	; Length of optional headers

sem2:	push	eax		; Part of code placed into import size and section name
	push	ebx
	push	ebx
	push	eax
	call	dword [MessageBoxA]
	ret
	nop

;; Section table (1 sections = overlays whole EXE file)

;	db	8 dup -1	; MZ+8C Section name			UNUSED
;	dd	secsize		; MZ+94 Virtual Size (memory allocated)
;	dd	0		; MZ+98 Virtual Adress
;	dd	secsize 	; MZ+9C Size of raw data
;	dd	0		; MZ+A0 Pointer to raw data
;	dd	-1		; MZ+A4 Pointer to relocations		UNUSED
;	dd	-1		; MZ+A8 Pointer to line numbers		UNUSED
;	dw	-1		; MZ+AC Number of relocations		UNUSED
;	dw	-1		; MZ+AE Number of line numbers		UNUSED
;	dd	0xE0000060	; MZ+B0 Charakteristics			UNUSED

	dd	secsize		; MZ+94 Virtual Size (memory allocated)
	dd	0		; MZ+98 Virtual Adress
	dd	secsize 	; MZ+9C Size of raw data
	dd	0		; MZ+A0 Pointer to raw data

secsize	=	$-base		; Size of section

;; Padding to 268 bytes (minimal exe file length for Win7+)

	if	$ < base + 0x10C
	db	0x10C + base - $ dup 0
	end if

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
